from instance.models import Instance
from instance.serializers import InstanceSerializer
from django.http import Http404
from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework import status
from implementation.vm.instance import OSVirtualMachineManager
import openstack


conn = openstack.connect(cloud='openstack')


class InstanceList(APIView):
    def get(self, request, format=None):
        instances = Instance.objects.all()
        # refresh OpenStack Attribs
        interface = OSVirtualMachineManager(conn)
        return Response([vm for vm in interface.list_all_vm()])
        # create response
        serializer = InstanceSerializer(instances, many=True)
        return Response(serializer.data)

    def post(self, request, format=None):
        data = request.data
        newId = 0
        interface = OSVirtualMachineManager(conn)
        imageId = "da51253f-867c-472d-8ce0-81e7b7126d60"
        flavorId = {"name": 1}
        networks = [{"uuid": "c03d0d4b-413e-4cc6-9ebe-c0b5ca0dac3a"}]
        interface.create_vm_from_template("Integration test vm 1", imageId, flavorId, networks)
        return Response(newId)


class InstanceDetail(APIView):
    """
    Retrieve, update or delete a snippet instance.
    """

    def get_object(self, pk):
        try:
            return Instance.objects.get(pk=pk)
        except Instance.DoesNotExist:
            raise Http404

    def get(self, request, pk, format=None):
        instance = self.get_object(pk)
        serializer = InstanceSerializer(instance)
        return Response(serializer.data)

    def put(self, request, pk, format=None):
        instance = self.get_object(pk)
        serializer = InstanceSerializer(instance, data=request.data)
        if serializer.is_valid():
            serializer.save()
            return Response(serializer.data)
        return Response(serializer.errors, status=status.HTTP_400_BAD_REQUEST)

    def delete(self, request, pk, format=None):
        instance = self.get_object(pk)
        instance.delete()
        return Response(status=status.HTTP_204_NO_CONTENT)
